% Copyright (C) 2013 - 2015 - Michael Baudin
%
% This file must be used under the terms of the 
% Creative Commons Attribution-ShareAlike 3.0 Unported License :
% http://creativecommons.org/licenses/by-sa/3.0/

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\section{Concrete orthogonal polynomials}

In this section, we present the Hermite, Legendre, Laguerre and Chebyshev orthogonal 
polynomials.

\subsection{Hermite polynomials}
\label{sec-hermitepoly}

\index{Hermite}
In this section, we present Hermite polynomials and their properties. 

Hermite polynomials are associated with the Gaussian weight:
\begin{eqnarray}
\label{eq-weighthermite}
w(x)=\exp(-x^2/2),
\end{eqnarray}
for $x\in\RR$.
The integral of this weight is:
\begin{eqnarray}
\int_\RR w(x) dx =\sqrt{2\pi}.
\end{eqnarray}
The distribution function for Hermite polynomials is the standard 
Normal distribution:
\begin{eqnarray}
\label{eq-pdfhermite}
f(x)=\frac{1}{\sqrt{2 \pi}} \exp\left(-\frac{x^2}{2}\right),
\end{eqnarray}
for $x\in\RR$. 

Here, we consider the \emph{probabilist} polynomials $He_n$, 
as opposed to the \emph{physicist} polynomials $H_n$ \cite{HermiteWikipedia}.

The first Hermite polynomials are
\begin{eqnarray*}
He_0(x)=1, \\
He_1(x)=x
\end{eqnarray*}
The remaining Hermite polynomials satisfy the recurrence:
\begin{eqnarray}
\label{eqn-hermiterec}
He_{n+1}(x) = xHe_n(x) - nHe_{n-1}(x),
\end{eqnarray}
for $n=1,2,...$.

\begin{example}
(\emph{First Hermite polynomials})
We have
\begin{eqnarray*}
He_2(x) 
&=& xHe_1(x) - He_0(x) \\
&=& x\cdot x - 1 \\
&=& x^2 - 1.
\end{eqnarray*}
Similarily, 
\begin{eqnarray*}
He_3(x) 
&=& xHe_2(x) - 2 He_1(x) \\
&=& x(x^2-1) - 2x \\
&=& x^3 - 3x.
\end{eqnarray*}
\end{example}

The first Hermite polynomials are presented in the figure \ref{fig-hermitepoly1-5}.

\begin{figure}
\begin{center}
\begin{tabular}{l}
\hline
$He_0(x)=1$\\
$He_1(x)=x$\\
$He_2(x)=x^2-1$\\
$He_3(x)=x^3-3x$\\
$He_4(x)=x^4-6x^2+3$\\
$He_5(x)=x^5-10x^3+15x$\\
\hline
\end{tabular}
\end{center}
\caption{Hermite polynomials}
\label{fig-hermitepoly1-5}
\end{figure}

The figure \ref{fig-Hermite03} plots the Hermite polynomials $He_n$, for $n=0,1,2,3$.

\begin{figure}[htbp]
\begin{center}
\includegraphics[width=0.6\textwidth]{figures/hermite0-3.pdf}
\end{center}
\caption{The Hermite polynomials $He_n$, for $n=0,1,2,3$.}
\label{fig-Hermite03}
\end{figure}

The figure \ref{fig-hermitepoly0-9} presents the coefficients $c_k$, for $k\geq 0$ of the 
Hermite polynomials, so that  
\begin{eqnarray}
He_n(x) = \sum_{k=0}^n c_k x^k.
\end{eqnarray}


\begin{figure}
\begin{center}
\begin{tabular}{l|llllllllll}
\hline
$n$ &$c_0$&$c_1$&$c_2$&$c_3$&$c_4$&$c_5$&$c_6$&$c_7$&$c_8$&$c_9$\\
\hline
0&1&&&&&&&&&\\
1&&1&&&&&&&&\\
2&-1&&1&&&&&&&\\
3&&-3&&1&&&&&&\\
4&3&&-6&&1&&&&&\\
5&&15&&-10&&1&&&&\\
6&-15&&45&&-15&&1&&&\\
7&&-105&&105&&-21&&1&&\\
8&105&&-420&&210&&-28&&1&\\
9&&945&&-1260&&378&&-36&&1\\
\hline
\end{tabular}
\end{center}
\caption{Coefficients of Hermite polynomials $He_n$, for $n=0,1,2,...,9$}
\label{fig-hermitepoly0-9}
\end{figure}

The Hermite polynomials are orthogonal with respect to the weight $w(x)$. 
Moreover, 
\begin{eqnarray}
\|He_n\|^2
&=& \sqrt{2\pi} n!.
\label{eq-hermitepolyorth}
\end{eqnarray}
Hence, 
\begin{eqnarray}
\label{eq-hermitepolyorth3}
V(He_n(X))
&=& n!,
\end{eqnarray}
for $n\geq 1$, where $X$ is a standard normal random variable. 

The following \scifun{HermitePoly} Scilab function creates the Hermite polynomial 
of order \scivar{n}.

\lstset{language=scilabscript}
\begin{lstlisting}
function y=HermitePoly(n)
    if (n==0) then
        y=poly(1,"x","coeff")
    elseif (n==1) then
        y=poly([0 1],"x","coeff")
    else
        polyx=poly([0 1],"x","coeff")
        // y(n-2)
        yn2=poly(1,"x","coeff")
        // y(n-1)
        yn1=polyx
        for k=2:n
            y=polyx*yn1-(k-1)*yn2
            yn2=yn1
            yn1=y
        end
    end
endfunction
\end{lstlisting}

The script:
\lstset{language=scilabscript}
\begin{lstlisting}
for n=0:10
    y=HermitePoly(x,n);
    disp(y)
end
\end{lstlisting}
produces the following output:
\lstset{language=scilabscript}
\begin{lstlisting}
    1   
 
    x   
 
         2  
  - 1 + x   
 
          3  
  - 3x + x   
 
          2   4  
    3 - 6x + x   
 
             3   5  
    15x - 10x + x   
\end{lstlisting}

\begin{proposition}
(\emph{Rodrigues formula for Hermite polynomials})
Hermite polynomials are so that :
\begin{eqnarray}
\label{eqn-rodriher}
He_n(x)=(-1)^n e^{\frac{x^2}{2}} \frac{d^n}{dx^n} \left(e^{-\frac{x^2}{2}} \right),
\end{eqnarray}
for $x\in \RR$.
\end{proposition}


The previous proposition will not be proved in this document.

\begin{proposition}
\label{prop-orthoher}
(\emph{Orthogonality of Hermite polynomials})
Hermite polynomials are orthogonal, and 
\begin{eqnarray}
\label{eqn-orthoherm}
(He_n,He_m) = \sqrt{2\pi} n! \delta_{nm},
\end{eqnarray}
for $n,m\geq 0$.
\end{proposition}

In terms of integrals, the previous equation is :
$$
\int_{-\infty}^\infty He_n(x) He_m(x) w(x) dx = \sqrt{2\pi} n! \delta_{nm},
$$
where $w$ is the weight of Hermite polynomials. 

\begin{proof}
Rodrigues' formula for Hermite polynomials imply :
\begin{eqnarray}
(He_n,He_m) 
&=& \int_{-\infty}^\infty He_n(x) He_m(x) w(x) dx \nonumber \\
&=& (-1)^{n} 
\int_{-\infty}^\infty e^{\frac{x^2}{2}} \frac{d^n}{dx^n} \left(e^{-\frac{x^2}{2}}\right) He_m(x) e^{-\frac{x^2}{2}}  dx \nonumber \\
&=& (-1)^{n} 
\int_{-\infty}^\infty \frac{d^n}{dx^n} \left(e^{-\frac{x^2}{2}}\right) He_m(x)  dx.
\label{eqn-orthoherm1}
\end{eqnarray}

Integrating by part, we get :
\begin{eqnarray*}
\int_{-\infty}^\infty \frac{d^n}{dx^n} \left(e^{-\frac{x^2}{2}}\right) He_m(x)  dx 
&=&\left[ \frac{d^{n-1}}{dx^{n-1}} \left(e^{-\frac{x^2}{2}}\right) He_m(x) \right]_{-\infty}^\infty  
- \int_{-\infty}^\infty \frac{d^{n-1}}{dx^{n-1}} \left(e^{-\frac{x^2}{2}}\right) \frac{d}{dx} He_m(x) dx
\end{eqnarray*}

However, 
\begin{eqnarray*}
\frac{d}{dx} \left(e^{-\frac{x^2}{2}}\right)
= -2x e^{-\frac{x^2}{2}}.
\end{eqnarray*}
This shows that $e^{-\frac{x^2}{2}}$ is a factor of the first derivative of $e^{-\frac{x^2}{2}}$. 
By recurrence, using the derivative of a product, this is also true for any derivative of $e^{-\frac{x^2}{2}}$. 
This implies :
\begin{eqnarray*}
\left[ \frac{d^{n-1}}{dx^{n-1}} \left(e^{-\frac{x^2}{2}}\right) He_m(x) \right]_{-\infty}^\infty = 0,
\end{eqnarray*}
for any integer $n$, since the limit of $e^{-\frac{x^2}{2}}$ at infinity is zero. 

Therefore, 
\begin{eqnarray*}
\int_{-\infty}^\infty \frac{d^n}{dx^n} \left(e^{-\frac{x^2}{2}}\right) He_m(x)  dx 
&=&- \int_{-\infty}^\infty \frac{d^{n-1}}{dx^{n-1}} \left(e^{-\frac{x^2}{2}}\right) \frac{d}{dx} He_m(x) dx
\end{eqnarray*}
Integrating by part $n-1$ more times, we get :
\begin{eqnarray*}
\int_{-\infty}^\infty \frac{d^n}{dx^n} \left(e^{-\frac{x^2}{2}}\right) He_m(x)  dx 
&=&(-1)^n \int_{-\infty}^\infty e^{-\frac{x^2}{2}} \frac{d^n}{dx^n} He_m(x) dx
\end{eqnarray*}
We plug the previous equation into \ref{eqn-orthoherm1} and get :
\begin{eqnarray}
(He_n,He_m) 
&=& (-1)^{n}  (-1)^n \int_{-\infty}^\infty e^{-\frac{x^2}{2}} \frac{d^n}{dx^n} He_m(x) dx \nonumber \\
&=& \int_{-\infty}^\infty e^{-\frac{x^2}{2}} \frac{d^n}{dx^n} He_m(x) dx
\label{eqn-orthoherm2}
\end{eqnarray}

We first assume that $n\neq m$ and prove that the integral is zero.

Assume that $n> m$ (otherwise, we just switch $n$ and $m$). 
Since $He_m$ is a degree $m$ polynomial, its $n$-th derivative is zero. 
This implies that the previous integral is zero, which proves that the equation \ref{eqn-orthoherm} 
is true when $n\neq m$. 

Secondly, assume that $n=m$. 
The equation \ref{eqn-orthoherm2} implies :
\begin{eqnarray*}
(He_n,He_n) 
&=& \int_{-\infty}^\infty e^{-\frac{x^2}{2}} \frac{d^n}{dx^n} He_n(x) dx.
\end{eqnarray*}
The equation \ref{eqn-hermiterec} implies that $He_n$ is a monic degree 
$n$ polynomial since the monomial with highest exponent 
is $xHe_n(x)$. 
In other words, the leading term of $He_n$ is $x^n$. 
The $n$-th derivative of this monomial is $n!$ and the $n$-th derivative of lower degree 
monomials is zero. 
Hence, 
\begin{eqnarray*}
(He_n,He_n) 
&=& n! \int_{-\infty}^\infty e^{-\frac{x^2}{2}} dx \\
&=& n! \sqrt{2\pi},
\end{eqnarray*}
where we have used the Gaussian integral proved in the section \ref{sec-gaussinteg}.
\end{proof}

Hermite polynomials are solutions of the following differential equation :
\begin{eqnarray*}
y'' - xy' = -n y.
\end{eqnarray*}
This leads to the following S-L equation :
\begin{eqnarray*}
\left(e^{-\frac{x^2}{2}}y'\right)' =- n e^{-\frac{x^2}{2}} y.
\end{eqnarray*}
The eigenvalue is $\lambda=n$, for $n=0,1,...$.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Legendre polynomials}

\index{Legendre}
In this section, we present Legendre polynomials and their properties. 

Legendre polynomials are associated with the 
unity weight
\begin{eqnarray*}
w(x)=1,
\end{eqnarray*}
for $x\in[-1,1]$.
We have
\begin{eqnarray*}
\int_{-1}^1 w(x) dx =2.
\end{eqnarray*}
The associated probability distribution function is:
\begin{eqnarray*}
f(x)=\frac{1}{2},
\end{eqnarray*}
for $x\in[-1,1]$.
This corresponds to the uniform distribution in probability theory.

The first Legendre polynomials are
\begin{eqnarray*}
P_0(x)=1, \\
P_1(x)=x
\end{eqnarray*}
The remaining Legendre polynomials satisfy the recurrence:
\begin{eqnarray*}
(n+1) P_{n+1}(x) = (2n+1) x P_n(x) - n P_{n-1}(x),
\end{eqnarray*}
for $n=1,2,...$.

\begin{example}
(\emph{First Legendre polynomials})
We have
\begin{eqnarray*}
2 P_2(x) 
&=&3xP_1(x)-P_0(x)\\
&=&3x^2-1,
\end{eqnarray*}
which implies
\begin{eqnarray*}
P_2(x) 
&=&\frac{1}{2}(3x^2-1).
\end{eqnarray*}
Similarily, 
\begin{eqnarray*}
3 P_3(x) 
&=& 5xP_2(x) -2P_1(x)\\
&=& 5x\frac{1}{2}(3x^2-1) -2x\\
&=& \frac{15}{2}x^3-\frac{5}{2}x - 2x \\
&=& \frac{15}{2}x^3-\frac{9}{2}x \\
&=& \frac{1}{2}(15x^3-9x).
\end{eqnarray*}
Finally, we divide both sides of the equation by $3$ and 
get
\begin{eqnarray*}
P_3(x) 
&=& \frac{1}{2}(5x^3-3x).
\end{eqnarray*}
\end{example}

The first Legendre polynomials are presented in the figure \ref{fig-legendrepoly1-5}.

\begin{figure}
\begin{center}
\begin{tabular}{l}
\hline
$P_0(x)=1$\\
$P_1(x)=x$\\
$P_2(x)=\frac{1}{2}(3x^2-1)$\\
$P_3(x)=\frac{1}{2}(5x^3-3x)$\\
$P_4(x)=\frac{1}{8}(35x^4-30x^2+3)$\\
$P_5(x)=\frac{1}{8}(63x^5-70x^3+15x)$\\
\hline
\end{tabular}
\end{center}
\caption{Legendre polynomials}
\label{fig-legendrepoly1-5}
\end{figure}

The Legendre polynomials are orthogonal with respect to $w(x)=1$. 
Moreover, 
\begin{eqnarray*}
\|P_n\|^2
&=& \frac{2}{2n+1}
\end{eqnarray*}
Furthermore, 
\begin{eqnarray*}
V(P_n(X))
&=& \frac{1}{2n+1},
\end{eqnarray*}
for $n\geq 1$, where $X$ is a random variable uniform in the interval $[-1,1]$.

The figure \ref{fig-Legendre03} plots the Legendre polynomials $P_n$, for $n=0,1,2,3$.

\begin{figure}[htbp]
\begin{center}
\includegraphics[width=0.6\textwidth]{figures/legendre0-3.pdf}
\end{center}
\caption{The Legendre polynomials $P_n$, for $n=0,1,2,3$.}
\label{fig-Legendre03}
\end{figure}

The following \scifun{LegendrePoly} Scilab function creates the Legendre polynomial 
of order \scivar{n}.

\lstset{language=scilabscript}
\begin{lstlisting}
function y=LegendrePoly(n)
    if (n==0) then
        y=poly(1,"x","coeff")
    elseif (n==1) then
        y=poly([0 1],"x","coeff")
    else
        polyx=poly([0 1],"x","coeff")
        // y(n-2)
        yn2=poly(1,"x","coeff")
        // y(n-1)
        yn1=polyx
        for k=2:n
            y=((2*k-1)*polyx*yn1-(k-1)*yn2)/k
            yn2=yn1
            yn1=y
        end
    end
endfunction
\end{lstlisting}

\begin{proposition}
(\emph{Rodrigues formula for Legendre polynomials})
Legendre polynomials are so that :
\begin{eqnarray}
\label{eqn-rodrileg}
P_n(x)=\frac{1}{2^n n!} \frac{d^n}{dx^n} ((x^2-1)^n),
\end{eqnarray}
for $x\in[-1,1]$.
\end{proposition}

The previous proposition will not be proved in this document.


\begin{proposition}
\label{prop-ortholeg}
(\emph{Orthogonality of Legendre polynomials})
Legendre polynomials are orthogonal, and 
\begin{eqnarray}
\label{eqn-ortholeg}
(P_n,P_m) = \frac{2}{2n+1} \delta_{nm},
\end{eqnarray}
for $n,m\geq 0$.
\end{proposition}

In terms of integrals, the previous equation is :
$$
\int_{-1}^1 P_n(x) P_m(x) w(x) dx = \frac{2}{2n+1} \delta_{nm},
$$
where $w$ is the weight of Legendre polynomials. 

\begin{proof}
We first prove the equation \ref{eqn-ortholeg} when $m\neq n$. 

Rodrigues' formula \ref{eqn-rodrileg} implies :
\begin{eqnarray*}
(P_n,P_m)
&=&\int_{-1}^1 P_n(x) P_m(x) w(x) dx  \\
&=& \frac{1}{2^{n+m} n! m!} \int_{-1}^1 \frac{d^n}{dx^n} ((x^2-1)^n) \frac{d^m}{dx^m} ((x^2-1)^m) dx.
\end{eqnarray*}
Integration by part implies :
\begin{eqnarray}
&&\int_{-1}^1 \frac{d^n}{dx^n} ((x^2-1)^n) \frac{d^m}{dx^m} ((x^2-1)^m) dx \nonumber \\
&&= 
\left[ \frac{d^{n-1}}{dx^{n-1}} ((x^2-1)^n) \frac{d^m}{dx^m} ((x^2-1)^m) dx \right]_{-1}^1 \nonumber \\
&& - \int_{-1}^1 \frac{d^{n-1}}{dx^{n-1}} ((x^2-1)^n) \frac{d^{m+1}}{dx^{m+1}} ((x^2-1)^m) dx.
\label{eqn-ortholeg1}
\end{eqnarray}

Differentiating the polynomial $(x^2-1)^n$ one times implies :
\begin{eqnarray*}
\frac{d}{dx} ((x^2-1)^n) = 2nx(x^2-1)^{n-1}.
\end{eqnarray*}
This shows that the first derivative of $(x^2-1)^n$ has $(x^2-1)^{n-1}$ as 
a factor. 
This is true up to the $(n-1)$-th derivative of $(x^2-1)^n$. 
Hence, the $(n-1)$-th derivative 
\begin{eqnarray*}
\frac{d^{n-1}}{dx^{n-1}} ((x^2-1)^n) 
\end{eqnarray*}
has $x^2-1$ as a factor. 
Therefore the $(n-1)$-th derivative of $(x^2-1)^n$ is equal to zero for $x=-1$ and $x=1$. 
Hence, the first expression in the equation \ref{eqn-ortholeg1} is zero, 
which implies :
\begin{eqnarray*}
&&\int_{-1}^1 \frac{d^n}{dx^n} ((x^2-1)^n) \frac{d^m}{dx^m} ((x^2-1)^m) dx \\
&&=- \int_{-1}^1 \frac{d^{n-1}}{dx^{n-1}} ((x^2-1)^n) \frac{d^{m+1}}{dx^{m+1}} ((x^2-1)^m) dx.
\end{eqnarray*}
We continue to integrate by part $n-1$ more times, and get :
\begin{eqnarray}
(P_n,P_m)
=\frac{(-1)^n}{2^{n+m} n! m!} \int_{-1}^1 (x^2-1)^n \frac{d^{m+n}}{dx^{m+n}} ((x^2-1)^m) dx,
\label{eqn-ortholeg2}
\end{eqnarray}
where the expression $(-1)^n$ comes from multiplying the minus sign 
in front of the integral $n$ times.

Now, suppose that $m<n$ (in the case where $m>n$, then we just switch $m$ and 
$n$). 
This implies $2m<m+n$. 
But the leading monomial of $(x^2-1)^m$ is $x^{2m}$, which 
implies that the derivative in the right hand side of the 
previous integral is zero, and concludes the first part of the 
proof.

We now prove the equation \ref{eqn-ortholeg} when $m= n$. 
The equation \ref{eqn-ortholeg2} implies :
\begin{eqnarray}
(P_n,P_n)
&=&\int_{-1}^1 P_n(x)^2 w(x) dx  \nonumber \\
&=&\frac{(-1)^n}{2^{2n} (n!)^2} \int_{-1}^1 (x^2-1)^n \frac{d^{2n}}{dx^{2n}} ((x^2-1)^n) dx,
\label{eqn-ortholeg3}
\end{eqnarray}

The polynomial $(x^2-1)^n$ has leading monomial $x^{2n}$. 
Differentiating this polynomial $2n$ times cancels all terms, 
except for the leading term $x^{2n}$. 
This implies :
\begin{eqnarray*}
\frac{d^{2n}}{dx^{2n}} ((x^2-1)^n) 
&=& \frac{d^{2n}}{dx^{2n}} x^{2n} \\
&=& (2n)!.
\end{eqnarray*}

We plug the previous equation into \ref{eqn-ortholeg3}, which implies 
\begin{eqnarray}
(P_n,P_n)
=(-1)^n  \frac{(2n)!}{2^{2n} (n!)^2} \int_{-1}^1 (x^2-1)^n dx.
\label{eqn-ortholeg4}
\end{eqnarray}

It can be proved (see section \ref{sec-legcos}) that 
\begin{eqnarray*}
\int_{-1}^1 (x^2-1)^n dx = (-1)^n \frac{(n!)^2 2^{2n+1}}{(2n+1)!}.
\end{eqnarray*}
We plug the previous equation into \ref{eqn-ortholeg4} and get :
\begin{eqnarray*}
(P_n,P_n)
&=&(-1)^n  \frac{(2n)!}{2^{2n} (n!)^2} (-1)^n \frac{(n!)^2 2^{2n+1}}{(2n+1)!} \\
&=&\frac{2}{2n+1},
\end{eqnarray*}
and concludes the proof.
\end{proof}

Legendre polynomials are solutions of the following differential equation :
\begin{eqnarray*}
(1-x^2) y'' -2xy' = - n(n+1) y.
\end{eqnarray*}
The associated S-L equation is :
\begin{eqnarray*}
\left((1-x^2) y'\right)' = -n(n+1) y.
\end{eqnarray*}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Laguerre polynomials}

\index{Laguerre}
In this section, we present Laguerre polynomials and their properties. 

Laguerre polynomials are associated with the 
weight
\begin{eqnarray*}
w(x)=\exp(-x),
\end{eqnarray*}
for $x\geq 0$. 

The figure \ref{fig-LaguerreW} plots the exponential weight function.

\begin{figure}[htbp]
\begin{center}
\includegraphics[width=0.5\textwidth]{figures/ExpW.pdf}
\end{center}
\caption{The Exponential weight.}
\label{fig-LaguerreW}
\end{figure}

We have:
\begin{eqnarray*}
\int_0^{+\infty} w(x) dx =1.
\end{eqnarray*}
Hence, the associated probability distribution function is:
\begin{eqnarray*}
f(x)=\exp(-x),
\end{eqnarray*}
for $x\geq 0$. 
This is the standard exponential distribution in probability theory.

The first Laguerre polynomials are
\begin{eqnarray*}
L_0(x)=1, \\
L_1(x)=-x+1
\end{eqnarray*}
The remaining Laguerre polynomials satisfy the recurrence:
\begin{eqnarray}
\label{fig-threeterm1lagu}
(n+1) L_{n+1}(x) = (2n+1-x) L_n(x) - n L_{n-1}(x),
\end{eqnarray}
for $n=1,2,...$.

The first Laguerre polynomials are presented in the figure \ref{fig-laguerrepoly1-5}.

\begin{figure}
\begin{center}
\begin{tabular}{l}
\hline
$L_0(x)=1$\\
$L_1(x)=-x+1$\\
$L_2(x)=\frac{1}{2!}(x^2-4x+2)$\\
$L_3(x)=\frac{1}{3!}(-x^3+9x^2-18x+6)$\\
$L_4(x)=\frac{1}{4!}(x^4-16x^3+72x^2-96x+24)$\\
$L_5(x)=\frac{1}{5!}(-x^5+25x^4-200x^3+600x^2-600x+120)$\\
\hline
\end{tabular}
\end{center}
\caption{Laguerre polynomials}
\label{fig-laguerrepoly1-5}
\end{figure}

\begin{example}
(\emph{First Laguerre polynomials})
We have
\begin{eqnarray*}
2 L_2(x) 
&=&(3-x)L_1(x) - L_0(x) \\
&=&(3-x)(1-x) - 1 \\
&=&3-x-3x+x^2-1 \\
&=&x^2-4x+2.
\end{eqnarray*}
Hence, 
\begin{eqnarray*}
L_2(x) 
&=&\frac{1}{2}(x^2-4x+2).
\end{eqnarray*}
Similarily, 
\begin{eqnarray*}
3 L_3(x) 
&=&(5-x)L_2(x)-2L_1(x)\\
&=&(5-x) \frac{1}{2}(x^2-4x+2) - 2(1-x).
\end{eqnarray*}
Therefore,
\begin{eqnarray*}
6 L_3(x) 
&=&(5-x) (x^2-4x+2) - 4(1-x) \\
&=&5x^2-20x+10-x^3+4x^2-2x-4+4x\\
&=&-x^3+9x^2-18x+6,
\end{eqnarray*}
which implies
\begin{eqnarray*}
L_3(x) 
&=&\frac{1}{6}(-x^3+9x^2-18x+6).
\end{eqnarray*}
\end{example}

The figure \ref{fig-Laguerre03} plots the Laguerre polynomials $L_n$, for $n=0,1,2,3$.

\begin{figure}[htbp]
\begin{center}
\includegraphics[width=0.6\textwidth]{figures/laguerre0-3.pdf}
\end{center}
\caption{The Laguerre polynomials $L_n$, for $n=0,1,2,3$.}
\label{fig-Laguerre03}
\end{figure}

The Laguerre polynomials are orthogonal with respect to $w(x)=\exp(-x)$. 
Moreover, 
\begin{eqnarray*}
\|L_n\|^2 
&=& 1.
\end{eqnarray*}
Furthermore,
\begin{eqnarray*}
V(L_n(X))
&=& 1,
\end{eqnarray*}
for $n\geq 1$, where $X$ is a standard exponential random variable.

The following \scifun{LaguerrePoly} Scilab function creates the Laguerre polynomial 
of order \scivar{n}.

\lstset{language=scilabscript}
\begin{lstlisting}
function y=LaguerrePoly(n)
    if (n==0) then
        y=poly(1,"x","coeff")
    elseif (n==1) then
        y=poly([1 -1],"x","coeff")
    else
        polyx=poly([0 1],"x","coeff")
        // y(n-2)
        yn2=poly(1,"x","coeff")
        // y(n-1)
        yn1=1-polyx
        for k=2:n
            y=((2*k-1-polyx)*yn1-(k-1)*yn2)/k
            yn2=yn1
            yn1=y
        end
    end
endfunction
\end{lstlisting}

\begin{proposition}
(\emph{Rodrigues formula for Laguerre polynomials})
Laguerre polynomials are so that :
\begin{eqnarray}
\label{eqn-rodrilagu}
L_n(x)=\frac{e^x}{n!} \frac{d^n}{dx^n} \left(x^ne^{-x} \right),
\end{eqnarray}
for $x\geq 0$.
\end{proposition}

The previous proposition will not be proved in this document.

\begin{proposition}
\label{prop-ortholagu}
(\emph{Orthogonality of Laguerre polynomials})
Laguerre polynomials are orthogonal, and 
\begin{eqnarray}
\label{eqn-ortholagu}
(L_n,L_m) = \delta_{nm},
\end{eqnarray}
for $n,m\geq 0$.
\end{proposition}

In terms of integrals, the previous equation is :
$$
\int_{0}^\infty L_n(x) L_m(x) w(x) dx = \delta_{nm},
$$
where $w$ is the weight of Laguerre polynomials. 

\begin{proof}
We first prove that :
\begin{eqnarray}
\label{eqn-ortholagu1}
(L_n, L_m ) =
\frac{(-1)^n}{n!} \int_{0}^\infty x^n e^{-x} \frac{d^n}{dx^n} L_m(x) dx.
\end{eqnarray}
Indeed, we can use the Rodrigues formula \ref{eqn-rodrilagu} then integrate by part. 
This leads to :
\begin{eqnarray}
(L_n, L_m ) 
&=& \int_{0}^\infty \frac{e^x}{n!} \frac{d^n}{dx^n} \left(x^ne^{-x} \right) L_m(x) e^{-x} dx \nonumber \\
&=& \frac{1}{n!} \int_{0}^\infty \frac{d^n}{dx^n} \left(x^ne^{-x} \right) L_m(x) dx \nonumber \\
&=& \frac{1}{n!} \left[ \frac{d^{n-1}}{dx^{n-1}} \left(x^ne^{-x} \right) L_m(x) \right]_{0}^\infty \nonumber \\
&&- \frac{1}{n!} \int_{0}^\infty \frac{d^{n-1}}{dx^{n-1}} \left(x^ne^{-x} \right) \frac{d}{dx} L_m(x) dx. \label{eqn-ortholagu2}
\end{eqnarray}
However, 
\begin{eqnarray*}
\frac{d}{dx} \left(x^n e^{-x} \right)
&=&nx^{n-1} e^{-x} - x^ne^{-x} \\
&=&(n-x) x^{n-1} e^{-x}.
\end{eqnarray*}
The previous equation implies that the first derivative of 
$x^n e^{-x}$ has $x^{n-1} e^{-x}$ as factor. 
By induction on $n$, this implies that 
$$
\frac{d^{n-1}}{dx^{n-1}} \left(x^ne^{-x} \right)
$$
must have $x e^{-x}$ as factor. 
Hence the first expression in the equation \ref{eqn-ortholagu2} is zero. 
This implies :
\begin{eqnarray*}
(L_n, L_m ) 
&=& - \frac{1}{n!} \int_{0}^\infty \frac{d^{n-1}}{dx^{n-1}} \left(x^ne^{-x} \right) \frac{d}{dx} L_m(x) dx.
\end{eqnarray*}
Using the same method $n-1$ more times leads to the equation \ref{eqn-ortholagu1}. 

Assume first that $n\neq m$. 
Therefore, we can assume that $n>m$ (otherwise, we can just switch $n$ and $m$).
In this case, we must have 
$$
\frac{d^n}{dx^n} L_m(x) = 0,
$$
since $L_m$ is a $m$-th degree polynomial. 
The equation \ref{eqn-ortholagu1} then implies :
\begin{eqnarray*}
(L_n, L_m ) = 0,
\end{eqnarray*}
and concludes the first part of the proof. 

Secondly, assume that $n=m$. 
The equation \ref{eqn-ortholagu1} combined with Rodrigues formula implies :
\begin{eqnarray}
(L_n, L_n ) 
&=& \frac{(-1)^n}{n!} \int_{0}^\infty x^n e^{-x} \frac{d^n}{dx^n} L_n(x) dx.
\label{eqn-ortholagu3}
\end{eqnarray}
The equation \ref{fig-threeterm1lagu} implies :
$$
L_{n+1}(x) = -\frac{x}{n+1} L_n(x) + \frac{2n+1}{n+1}L_n(x) - \frac{n}{n+1} L_{n-1}(x),
$$
for $n=1,2,...$. 
Since $L_1(x)=1$, this implies that the leading term of $L_n(x)$ is 
$$
(-1)^n \frac{x^n}{n!}. 
$$
Therefore, 
$$
\frac{d^n}{dx^n} L_n(x) = (-1)^n \frac{n!}{n!} = (-1)^n.
$$
We plug the previous equation into \ref{eqn-ortholagu3} and get :
\begin{eqnarray*}
(L_n, L_n ) 
&=& \frac{(-1)^{2n}}{n!} \int_{0}^\infty x^n e^{-x} dx \nonumber \\
&=& \frac{1}{n!} \int_{0}^\infty x^n e^{-x} dx. \\
&=& \frac{n!}{n!} \\
&=& 1,
\end{eqnarray*}
where we have used the proposition \ref{prop-laguint}, page \pageref{prop-laguint}, 
which proves that 
$$
\int_{0}^\infty x^n e^{-x} dx = n!,
$$
for $n\geq 0$.
\end{proof}

Laguerre polynomials are solutions of the following differential equation :
\begin{eqnarray*}
x y'' + (1-x)y' = - n y .
\end{eqnarray*}
The associated S-L equation is :
\begin{eqnarray*}
\left(xe^{-x} y'\right)' = -ne^{-x} y.
\end{eqnarray*}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Chebyshev polynomials of the first kind}
\label{sec-chebyshev}

\index{Chebyshev}
In this section, we present Chebyshev polynomials of the first kind 
and their properties. 

It is important to mention that Chebyshev polynomials of the second kind 
are not presented in this document.

\begin{proposition}
\label{prop-trigo}
(\emph{A trigonometry property})
For any integers $n$ and $m$, we have 
\begin{eqnarray}
\label{eqn-trigocheby}
\cos(n\theta)\cos(m\theta) 
= \frac{1}{2} \cos((n+m)\theta) + \frac{1}{2} \cos((n-m)\theta),
\end{eqnarray}
for any $\theta\in\RR$.
\end{proposition}

We will not prove the previous proposition in this document.

\begin{definition}
(\emph{Chebyshev polynomials})
\label{def-chebypoly}
For any $x\in[-1,1]$, the Chebyshev polynomial is 
\begin{eqnarray}
\label{eqn-defcheby}
T_n(x)=\cos(n\arccos(x)),
\end{eqnarray}
for $n=0,1,...$.
\end{definition}

It is not obvious that $T_n$ is a polynomial : this will be 
proved later in this document. 
However, we can see that this is true for $n=0$ and 
$n=1$, since 
\begin{eqnarray*}
T_0(x)=1, \\
T_1(x)=x,
\end{eqnarray*}
for any $x\in[-1,1]$. 

\begin{proposition}
(\emph{Three term recurrence for Chebyshev polynomials})
Chebyshev polynomials are so that :
\begin{eqnarray}
\label{eqn-chebyrecurr}
T_{n+1}(x) = 2x T_n(x) - T_{n-1}(x),
\end{eqnarray}
for any $x\in[-1,1]$. 
\end{proposition}

The previous proposition implies that Chebyshev functions are, 
indeed, polynomials since $T_0$ and $T_1$ are polynomials. 

\begin{proof}
Let 
$$
\theta=\arccos(x),
$$
for any $x\in[-1,1]$. 
This implies 
$$
T_n(x)=\cos(n\theta),
$$
for any $n=0,1,...$. 
The equation \ref{eqn-trigocheby} with $m=1$ implies :
\begin{eqnarray}
\cos(n\theta)\cos(\theta) 
&=& \frac{1}{2} \cos((n+1)\theta) + \frac{1}{2} \cos((n-1)\theta) \nonumber \\
&=& \frac{1}{2} T_{n+1}(x) + \frac{1}{2} T_{n-1}(x).
\label{eqn-chebyrecurr0}
\end{eqnarray}
Moreover, 
\begin{eqnarray*}
\cos(n\theta)\cos(\theta) 
&=& T_n(x) x,
\end{eqnarray*}
which, combined with the equation \ref{eqn-chebyrecurr0}, leads 
to \ref{eqn-chebyrecurr}.
\end{proof}

The first Chebyshev polynomials are presented in the figure \ref{fig-Chebyshevpoly1-5}.

\begin{figure}
\begin{center}
\begin{tabular}{l}
\hline
$T_0(x)=1$\\
$T_1(x)=x$\\
$T_2(x)=2x^2-1$\\
$T_3(x)=4x^3-3x$\\
$T_4(x)=8x^4-8x^2+1$\\
$T_5(x)=16x^5-20x^3+5x$\\
\hline
\end{tabular}
\end{center}
\caption{Chebyshev polynomials of the first kind}
\label{fig-Chebyshevpoly1-5}
\end{figure}

\begin{example}
(\emph{First Chebyshev polynomials})
We have
\begin{eqnarray*}
T_2(x)
&=&2xT_1(x)-T_0(x)\\
&=&2x^2-1.
\end{eqnarray*}
Similarily, 
\begin{eqnarray*}
T_3(x)
&=&2xT_2(x)-T_1(x)\\
&=&2x(2x^2-1)-x\\
&=&4x^3-2x-x\\
&=&4x^3-3x.
\end{eqnarray*}
\end{example}

The figure \ref{fig-Chebyshev03} plots the Chebyshev polynomials $T_n$, for $n=0,1,2,3$.

\begin{figure}[htbp]
\begin{center}
\includegraphics[width=0.6\textwidth]{figures/chebyshev0-3.pdf}
\end{center}
\caption{The Chebyshev polynomials $T_n$, for $n=0,1,2,3$.}
\label{fig-Chebyshev03}
\end{figure}

The following \scifun{chebyshev\_poly} Scilab function creates the Chebyshev polynomial 
of order \scivar{n}.

\lstset{language=scilabscript}
\begin{lstlisting}
function y=chebyshev_poly(n)
    if (n==0) then
        y=poly(1,"x","coeff")
    elseif (n==1) then
        y=poly([0 1],"x","coeff")
    else
        polyx=poly([0 1],"x","coeff")
        // y(n-2)
        yn2=poly(1,"x","coeff")
        // y(n-1)
        yn1=polyx
        for k=2:n
            y=2*polyx*yn1-yn2
            yn2=yn1
            yn1=y
        end
    end
endfunction
\end{lstlisting}

\begin{proposition}
(\emph{Orthogonality of Chebyshev polynomials})
The Chebyshev polynomials are orthogonal with 
respect to the weight 
\begin{eqnarray}
\label{eqn-chebyweight}
w(x)=\frac{1}{\sqrt{1-x^2}},
\end{eqnarray}
for $x\in[-1,1]$. 
Moreover, 
\begin{eqnarray}
\label{eqn-chebyprod}
(T_n,T_m)
&=& \int_{-1}^1 T_n(x) T_m(x) w(x) dx = \frac{\pi}{2} \delta_{nm},
\end{eqnarray}
for any integers $n$ and $m$. 
\end{proposition}

The weight defined by the equation \ref{eqn-chebyweight} does 
not correspond to a particular distribution in 
probability theory.

\begin{proof}
First, notice that 
\begin{eqnarray}
\label{eqn-arccosp}
\arccos'(x)=\frac{1}{\sqrt{1-x^2}},
\end{eqnarray}
for $x\in[-1,1]$. 
Using the change of variable $\theta=\arccos(x)$ 
and the equation \ref{eqn-trigocheby}, we get :
\begin{eqnarray*}
(T_n,T_m)
&=& \int_{-1}^1 T_n(x) T_m(x) \frac{1}{\sqrt{1-x^2}} dx \\
&=& - \int_\pi^0 \cos(n\theta) \cos(m\theta) d\theta \\
&=& \int_0^\pi \cos(n\theta) \cos(m\theta) d\theta \\
&=& \frac{1}{2} \int_0^\pi \left( \cos((n+m)\theta) + \cos((n-m)\theta) \right) d\theta.
\end{eqnarray*}

If $n\neq m$, then 
\begin{eqnarray*}
(T_n,T_m)
&=& \frac{1}{2} \left[ \frac{\sin((n+m)\theta)}{n+m} + \frac{\sin((n-m)\theta)}{n-m} \right]_0^\pi \\
&=& 0,
\end{eqnarray*}
since $\sin(j\theta)=0$ for $\theta=0$ or $\theta=\pi$, 
for any integer $j$. 
This shows that the equation \ref{eqn-chebyprod} is true 
for $n\neq m$. 

If, on the other hand, we have $n=m$, then 
\begin{eqnarray*}
(T_n,T_m)
&=& \frac{1}{2} \int_0^\pi \left( \cos((n+m)\theta) + 1 \right) d\theta \\
&=& \frac{1}{2} \int_0^\pi \left( \cos(2n\theta) + 1 \right) d\theta \\
&=& \frac{1}{2} \left[ \frac{\sin(2n\theta)}{2n} + \theta \right]_0^\pi \\
&=& \frac{1}{2},
\end{eqnarray*}
which concludes the proof.
\end{proof}

\begin{proposition}
(\emph{Roots of Chebyshev polynomials})
The Chebyshev polynomial of degree $n$ has $n$ 
simple real roots in $[-1,1]$, which are :
\begin{eqnarray}
\label{eqn-chebyroot}
x_k=\cos\left(\frac{2k-1}{2n} \pi \right),
\end{eqnarray}
for $k=1,...,n$. 
\end{proposition}

\begin{proof}
The equation \ref{eqn-chebyroot} implies :
\begin{eqnarray}
\arccos(x_k)=\frac{2i-1}{2n} \pi,
\end{eqnarray}
which implies 
\begin{eqnarray*}
T_n(x_k)
&=& \cos\left(n\arccos\left(x_k\right)\right) \\
&=& \cos\left(n\frac{2i-1}{2n} \pi\right) \\
&=& \cos\left(\frac{2i-1}{2} \pi\right) \\
&=&0,
\end{eqnarray*}
which concludes the proof.
\end{proof}

There is one small issue with the equation \ref{eqn-chebyroot}. 
When $k=1,...,n$, the roots $x_1,...,x_n$ are from the end of the 
interval $[-1,1]$ to the beginning. 
This might be surprising, because we may expect that the 
roots are in increasing order.  
This issue is solved by the following proposition.

\begin{proposition}
The roots of the Chebyshev polynomial of degree $n$ are :
\begin{eqnarray}
\label{eq-chebynodes}
x_k = -\cos\left(\frac{2k-1}{2n}\pi\right),
\end{eqnarray}
for $k=1,...,n$. 
\end{proposition}

The roots defined by the equation \ref{eq-chebynodes} 
are computed in increasing order when $k=1,...,n$ and are 
the same as the roots defined by the equation \ref{eqn-chebyroot}. 

\begin{proof}
Notice that :
$$
\cos(\theta)=-\cos(\pi-\theta),
$$
for any $\theta\in\RR$.
Hence, 
\begin{eqnarray*}
-\cos\left(\frac{2k-1}{2n}\pi\right)
&=& \cos\left(\pi - \frac{2k-1}{2n}\pi\right) \\
&=& \cos\left(\frac{2n-2k+1}{2n}\pi\right) \\
&=& \cos\left(\frac{2(n-k+1)-1}{2n}\pi\right) \\
&=& \cos\left(\frac{2j-1}{2n}\pi\right),
\end{eqnarray*}
with $j=n-i+1$. 
\end{proof}

The corresponding weights in the quadrature rule are 
\begin{eqnarray}
\label{eq-chebyweights}
\alpha_k = \frac{\pi}{n},
\end{eqnarray}
for $k=1,...,n$. 

\begin{proposition}
(\emph{Extrema of Chebyshev polynomials})
The extrema of the Chebyshev polynomial of degree $n$ are :
\begin{eqnarray}
\label{eqn-chebyext}
x_k=\cos\left(\frac{k\pi}{n}\right),
\end{eqnarray}
for $k=1,...,n$. 
They are so that 
\begin{eqnarray}
\label{eqn-chebyext2}
T_n(x_k)=(-1)^k,
\end{eqnarray}
for $k=1,...,n$. 
\end{proposition}


\begin{proof}
The equation \ref{eqn-defcheby} implies that the 
derivative of $T_n$ is :
\begin{eqnarray*}
T_n'(x)
&=& - n\sin(n \arccos(x)) \arccos'(x) \\
&=& \frac{n\sin(n \arccos(x))}{\sqrt{1-x^2}},
\end{eqnarray*}
where the derivative of $\arccos$ is given by the equation \ref{eqn-arccosp}. 
Therefore, we have $T_n'(x_k)=0$ if 
\begin{eqnarray*}
\sin(\arccos(x_k))=0,
\end{eqnarray*}
for $k=1,...,n$ and $x_k\neq \pm 1$.
This implies that the argument of $\sin$ must be a multiple of 
$\pi$ :
\begin{eqnarray*}
n \arccos(x_k) = k\pi,
\end{eqnarray*}
which implies the equation \ref{eqn-chebyext}. 
Moreover, the abscissas defined by the equation \ref{eqn-chebyext} 
are different from -1 and 1, so that the derivative 
of $T_n$ is well defined for these points. 

We plug the equation \ref{eqn-chebyext} into the equation \ref{eqn-defcheby} 
and get :
\begin{eqnarray*}
T_n(x_k) 
&=& \cos\left(k\pi\right) \\
&=& (-1)^k,
\end{eqnarray*}
for $k=1,...,n$, which concludes the proof.
\end{proof}

Chebyshev polynomials are solutions of the following differential equation :
\begin{eqnarray*}
(1-x^2) y'' -xy' = - n^2 y,
\end{eqnarray*}
for $x\in[-1,1]$.
The associated S-L equation is :
\begin{eqnarray*}
\left(\frac{1}{\sqrt{1-x^2}} y'\right)' = -\frac{n^2}{\sqrt{1-x^2}}y.
\end{eqnarray*}

The figure \ref{fig-cheby11} presents the polynomial $T_{11}$. 
It is produced by the following script, which uses the 
\scifun{cheby\-shev\_eval} function in order to evaluate $T_{11}$ 
on the interval $[-1,1]$. 
Then we use the \scifun{cheby\-shev\_quadrature} function in order 
to computes the roots \scifun{r} and the weights \scifun{w} of the 
Gauss-Chebyshev quadrature. 
\lstset{language=scilabscript}
\begin{lstlisting}
n=11;
x=linspace(-1,1,100);
y=chebyshev_eval(x,n);
plot(x,y)
[r,w]=chebyshev_quadrature(n);
plot(r,zeros(r),"rx")
xlabel("x")
ylabel("P(x)")
title(msprintf("Chebyshev polynomial - Degree %d",n))
\end{lstlisting}
We can see that the roots of the Chebyshev polynomial have 
a higher density at the ends of the interval $[-1,1]$. 
Moreover, we check that the polynomial $T_{11}$ oscillates, 
although its absolute value is always lower than 1, 
as predicted by the equation \ref{eqn-chebyext2}.

\begin{figure}
\begin{center}
\includegraphics[width=0.7\textwidth]{figures/cheby11.pdf}
\end{center}
\caption{
Degree 11 Chebyshev polynomial.
}
\label{fig-cheby11}
\end{figure}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Accuracy of evaluation of the polynomial}

In this section, we present the accuracy issues which 
appear when we evaluate the orthogonal polynomials with 
large values of the polynomial degree $n$.
More precisely, we present a fundamental limitation in the 
accuracy that can be achieved by the polynomial representation 
of the orthogonal polynomials, while a sufficient accuracy can 
be achieved with a different evaluation algorithm. 

The following \scifun{LaguerreEval} function evaluates the 
Laguerre polynomial of degree \scivar{n} at point \scivar{x}. 
One one hand, the \scifun{LaguerrePoly} function creates a polynomial 
which can be evaluated with the \scifun{horner} function, while, on 
the other hand, the function \scifun{LaguerreEval} directly evaluates 
the polynomial. 
As we are going to see soon, although the recurrence is the same, 
the numerical performances of these two functions is rather different. 

\lstset{language=scilabscript}
\begin{lstlisting}
function y=LaguerreEval(x,n)
    if (n==0) then
        nrows=size(x,"r")
        y=ones(nrows,1)
    elseif (n==1) then
        y=1-x
    else
        // y(n-2)
        yn2=1
        // y(n-1)
        yn1=1-x
        for k=2:n
            y=((2*k-1-x).*yn1-(k-1)*yn2)/k
            yn2=yn1
            yn1=y
        end
    end
endfunction
\end{lstlisting}

Consider the value of the polynomial $L_{100}$ at the point $x=10$. 
From Wolfram Alpha, which uses an arbitrary precision computer system, 
the exact value of $L_{100}(10)$ is
$$
13.277662844303454137789892644070318985922997400185621...
$$
In the following session, we compare the accuracies of \scifun{LaguerrePoly} 
and \scifun{LaguerreEval}. 
\lstset{language=scilabscript}
\begin{lstlisting}
-->n=100;
-->x=10;
-->L=LaguerrePoly(n);
-->y1=horner(L,x)
 y1  =
    3.695D+08  
-->y2=LaguerreEval(x,n)
 y2  =
    13.277663  
\end{lstlisting}
We see that the polynomial created by \scifun{LaguerrePoly} 
does not produce a sufficient accuracy, while \scifun{LaguerreEval} 
seems to be accurate. 
In fact, the value produced by \scifun{LaguerreEval} has more than 15 
correct decimal digits.

In order to see the trend when $x$ and $n$ increases, we compute the 
number of common digits, in base 2, in the evaluation of $L_n(x)$, 
computed from \scifun{LaguerrePoly} and \scifun{LaguerreEval}. 
Since Scilab uses double precision floating point numbers with 64 
bits and 53 bits of precision, this number varies from 53 (when 
the two functions return exactly the same value) 
to 0 (when the two functions return two value which have no 
digit in common).
The figure \ref{fig-LaguerreD} plots the number of common digits, 
when $n$ ranges from 1 to 100 and $x$ ranges from 1 to 21.

\begin{figure}
\begin{center}
\includegraphics[width=0.5\textwidth]{figures/laguerredigits.pdf}
\end{center}
\caption{
The number of common digits in the evaluation of Laguerre polynomials, 
for increasing $n$ and $x$.
}
\label{fig-LaguerreD}
\end{figure}

We see that the number of correct digits produced by \scifun{LaguerrePoly} 
decreases when $x$ and $n$ increase. 

The explanation for this fact is that the polynomial representation of 
the Laguerre polynomial forces to use $n=100$ additions 
of positive and negative powers of $x$. 
This computation is ill-conditionned, because it involves large numbers 
with different signs.

For example, the following session presents some of the coefficients 
of $L_{100}$.
\lstset{language=scilabscript}
\begin{lstlisting}
-->L
 L  =
                    2        3            4         5            6       
    1 - 100x + 2475x - 26950x + 163384.37x - 627396x + 1655628.3x        
                        7            8             9           10        
            - 3176103.3x + 4615275.2x - 5242040.9x + 4770257.2x          
[...]
                        95           96           97           98        
            - 7.28D-141x + 3.95D-144x - 1.68D-147x + 5.25D-151x          
                         99          100                                 
            - 1.07D-154x + 1.07D-158x                                    
\end{lstlisting}
We see that the coefficients signs alternate. 

Consider $n$ real numbers $y_i$, for $i=1,2,...,n$, representing the 
monomial values which appear in the polynomial representation. 
We are interested in the sum 
$$
S=y_1+y_2+...+y_n.
$$
We know from numerical analysis \cite{Higham:2002:ASN} that the 
condition number of a sum is
$$
\frac{|y_1|+|y_2|+...|y_n|}{|y_1+y_2+...y_n|}.
$$
Hence, when the sum $S$ is small in magnitude, but involves 
large terms $y_i$, the condition number is large. 
In other words, small relative errors in $y_i$ are converted into 
large relative errors in $S$, and this is what happens for polynomials. 

Hence, the polynomial representation should be avoided in practice to 
evaluate the orthogonal polynomial, although they are a convenient 
way of using them in Scilab. 
On the other hand, a straightforward evaluation of the polynomial 
value based on the recurrence formula can produce a good accuracy.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Notes and references}

The classic \cite{abramowitz+stegun} gives a brief overview of the 
main results on orthogonal polynomials in the chapter 22 "Orthogonal polynomials". 
More details on orthogonal polynomials are presented 
in \cite{Arfken2005}, especially the chapter 12 "Legendre functions" and 
chapter 13 "More special functions". 

The book \cite{AnAsRo99} has three chapters on orthogonal polynomials, 
including quadrature, and other advanced topics.

One of the references on the topic is \cite{Szego1975}, which covers the 
topic in depth.

In the appendices of \cite{LeMaitreKnio2010}, we can find a 
presentation of the most common orthogonal polynomials 
used in uncertainty analysis.

The proposition \ref{prop-ortholeg} is given in \cite{Griffiths2005}, chapter 6.



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
